#include<windows.h> /* God Damn it Leroy, you're so )*#)(#@ stupid */
#include<MMSystem.h> /* The Joystick API */
#include<stdio.h> /* Ahh good OLD fashioned I/O */
#include<math.h> /*Now we're getting technical */
#include"functions.h"

void recognition() {
//	double Accs[MAX];	// General acceleration, used to check if it is moving

	// Store all the accelerations, but delete the old ones
	double accsX[HOWLONG];
	double accsY[HOWLONG];
	double accsZ[HOWLONG];

	double shortX[MXSHORT];
	double shortY[MXSHORT];
	double shortZ[MXSHORT];

	double longX[MXLONG];
	double longY[MXLONG];
	double longZ[MXLONG];

	double	hadoukX[SHORTNORM],	hadoukY[SHORTNORM],	hadoukZ[SHORTNORM];
	double	alphaX[LONGNORM],	alphaY[LONGNORM],	alphaZ[LONGNORM];
	double	rightX[SHORTNORM],	rightY[SHORTNORM],	rightZ[SHORTNORM];
	double	downX[SHORTNORM],	downY[SHORTNORM],	downZ[SHORTNORM];
	double	leftX[SHORTNORM],	leftY[SHORTNORM],	leftZ[SHORTNORM];
	double	castX[SHORTNORM],	castY[SHORTNORM],	castZ[SHORTNORM];
	double  upX[SHORTNORM],		upY[SHORTNORM],		upZ[SHORTNORM];

	double* AllRefs[] = {downX, downY, downZ, upX, upY, upZ, leftX, leftY, leftZ, rightX, rightY, rightZ, alphaX, alphaY, alphaZ, castX, castY, castZ, hadoukX, hadoukY, hadoukZ};

	int index = 0;		// index % MAX is which one we just added to
	double AccX = 0,AccY = 0,AccZ = 0; /* Acceleration Values */
	//double AccX,AccY,AccZ;
	double OldAX = 0, OldAY = 0, OldAZ = 0;	// old acceleration values
	int jid,jidmax,jidconnected; /* Joystick ID */
	unsigned int Buttons;
	double pitch = 0, tilt = 0, roll = 0; /* In degrees */
    //double Vx, Vy, Vz, Dx = 0, Dy = 0, Dz = 0;
	double calibrationData[MAXSENSORS][3];
	//long start,end,diff;

	struct GESTURESTRUCT gestureDown, gestureLeft, gestureUp, gestureRight, gestureAlpha, gestureCast, gestureHadouk;

	int numReadings = 0;
	int reOrdered = 1;	// true
	int wasMoving = 0;	// false
	int counter = 1;

//	FILE* file;


	// Load comparable data for each gesture
	if (!openFile(downX, downY, downZ, "output/outputdown.txt")) {
		printf("Error opening reference file, ABORTING\n");
		return;
	}

	if (!openFile(leftX, leftY, leftZ, "output/outputleft.txt")) {
		printf("Error opening reference file, ABORTING\n");
		return;
	}

	if (!openFile(upX, upY, upZ, "output/outputup.txt")) {
		printf("Error opening reference file, ABORTING\n");
		return;
	}
	if (!openFile(rightX, rightY, rightZ, "output/outputright.txt")) {
		printf("Error opening reference file, ABORTING\n");
		return;
	}
	if (!openFile(alphaX, alphaY, alphaZ, "output/outputalpha.txt")) {
		printf("Error opening reference file, ABORTING\n");
		return;
	}
	if (!openFile(castX, castY, castZ, "output/outputcast.txt")) {
		printf("Error opening reference file, ABORTING\n");
		return;
	}
	if (!openFile(hadoukX, hadoukY, hadoukZ, "output/outputhadouk.txt")) {
		printf("Error opening reference file, ABORTING\n");
		return;
	}
	/*
	if (!openFile(fwardX, fwardY, fwardZ, "output/outputfward.txt")) {
		printf("Error opening reference file, ABORTING\n");
		return;
	}*/

	if(!openDataBank(&gestureDown, DOWN)) {
		printf("Error opening File Bank\n");
		return;
	}

	if(!openDataBank(&gestureLeft, LEFT)) {
		printf("Error opening File Bank\n");
		return;
	}

	if(!openDataBank(&gestureUp, UP)) {
		printf("Error opening File Bank\n");
		return;
	}

	if(!openDataBank(&gestureRight, RIGHT)) {
		printf("Error opening File Bank\n");
		return;
	}

	if(!openDataBank(&gestureAlpha, ALPHA)) {
		printf("Error opening File Bank\n");
		return;
	}

	if(!openDataBank(&gestureCast, CAST)) {
		printf("Error opening File Bank\n");
		return;
	}

	if(!openDataBank(&gestureHadouk, HADOUK)) {
		printf("Error opening File Bank\n");
		return;
	}

	jidmax = joyGetNumDevs(); 
	jidconnected = joyGetNumDevicesConnected();
	printf("We can hookup %d devices\n",jidmax);
	printf("We have %d devices connected\n",jidconnected);
	calibrateAllSensors(calibrationData);
	
	while(1) {
		printf("\r"); // start on the same line
		//start = timeGetTime();
		Sleep(33);
		for(jid=0; jid<jidconnected; jid++) {
			if (getRawSensorData(jid,&AccX,&AccY,&AccZ,&Buttons)) {
			//	Accs[index % MAX] = sqrt(AccX*AccX+AccY*AccY+AccZ*AccZ);
				accsX[index % HOWLONG] = AccX;
				accsY[index % HOWLONG] = AccY;
				accsZ[index % HOWLONG] = AccZ;
				index++;

				if (Buttons) {
				/*	if (Buttons && JOY_BUTTON1) {
						printf("Reading Data...");
						Sleep(100);
						while(1) {
							if (getRawSensorData(jid,&AccX,&AccY,&AccZ,&Buttons)) {
								Sleep(33);
								Accs[index % MAX] = sqrt(AccX*AccX+AccY*AccY+AccZ*AccZ);

								accsX[index % HOWLONG] = AccX;
								accsY[index % HOWLONG] = AccY;
								accsZ[index % HOWLONG] = AccZ;

								index++;
							}
							*/
					Sleep(100);
					printf("Reading Data...");
					while (Buttons & JOY_BUTTON1 || Buttons & JOY_BUTTON2) {						
						if (getRawSensorData(jid,&AccX,&AccY,&AccZ,&Buttons)) {
							Sleep(33);
					//		Accs[index % MAX] = sqrt(AccX*AccX+AccY*AccY+AccZ*AccZ);

							accsX[index % HOWLONG] = AccX;
							accsY[index % HOWLONG] = AccY;
							accsZ[index % HOWLONG] = AccZ;

							index++;
						}
						if (index >= HOWLONG) {
							//	reOrdered = 0;
							numReadings++;
						}
					}
					if (numReadings) {	// if it was moving, now it isn't
						reOrdered = 0;
						printf("DONE\n");
					}
				}
				if (!reOrdered) {
					printf("numReadings: %d\n", numReadings);
					if (numReadings > MNSHORT && numReadings <= MXSHORT) {		//<<<<<<<<<<<<<<<<<<<
						printf("%d. SHORT GESTURE\n", counter);
						reorderArray(accsX, shortX, index, numReadings);
						reorderArray(accsY, shortY, index, numReadings);
						reorderArray(accsZ, shortZ, index, numReadings);
						checkGesture(shortX, shortY, shortZ, AllRefs, &gestureUp, 8.25, numReadings);
						checkGesture(shortX, shortY, shortZ, AllRefs, &gestureDown, 7.75, numReadings);
						checkGesture(shortX, shortY, shortZ, AllRefs, &gestureLeft, 8.25, numReadings);
						checkGesture(shortX, shortY, shortZ, AllRefs, &gestureRight, 9.25, numReadings);
						checkGesture(shortX, shortY, shortZ, AllRefs, &gestureCast, 13.45, numReadings);
						checkGesture(shortX, shortY, shortZ, AllRefs, &gestureHadouk, 10.25, numReadings);
				/*		file = fopen("differences.txt", "a");
						if (file) {
							fprintf(file, "\n");
							fclose(file);
						}*/
						counter++;
					}
					else if (numReadings > MNLONG && numReadings <= MXLONG) {	//<<<<<<<<<<<<<<<<<<<
						reorderArray(accsX, longX, index, numReadings);
						reorderArray(accsY, longY, index, numReadings);
						reorderArray(accsZ, longZ, index, numReadings);
						printf("LONG GESTURE\n");
						checkGesture(longX, longY, longZ, AllRefs, &gestureAlpha, 8.65, numReadings);
					}
					reOrdered = 1;
					numReadings = 0;
				}
			}
		}
	}
}

//	DOWN: 4.375		LEFT: 4.6875		UP: 5.0			RIGHT: 4.6875
//	DOWN: 4.927887	LEFT: 5.579575		UP: 4.227647	RIGHT: 3.808293
//	DOWN: 4.874389	LEFT: 5.605979		UP:	4.134126	RIGHT: 3.689678		ALPHA: 7.277652		CAST:	5.974147
//	DOWN: 4.650845	LEFT: 5.235889		UP: 4.943493	RIGHT: 3.875901		ALPHA: 8.507216		CAST:	5.869339	HADOUK:	3.859729

int getRawSensorData(int sensorID, double *AccX, double *AccY, double *AccZ, unsigned int *Buttons) {
	JOYINFOEX joystickInfo;
	MMRESULT  res;

	memset(&joystickInfo,0,sizeof(JOYINFOEX));
	joystickInfo.dwSize = sizeof(JOYINFOEX);
	joystickInfo.dwFlags = JOY_RETURNX | JOY_RETURNY | JOY_RETURNZ | JOY_RETURNBUTTONS;

	if ((res = joyGetPosEx(sensorID,&joystickInfo)) == JOYERR_NOERROR) {
		//Pass on Button Press information
		*Buttons = joystickInfo.dwButtons;
		//Compute Accerlation from Joystick Info data
		*AccX = ((int)((((int)joystickInfo.dwXpos-32768)/13107.2)*100))/100.0;
		*AccY = ((int)((((int)joystickInfo.dwYpos-32768)/13107.2)*100))/100.0;
		*AccZ = ((int)((((int)joystickInfo.dwZpos-32768)/13107.2)*100))/100.0;
		return 1;
	}
	switch(res) {
		case MMSYSERR_NODRIVER: printf("The joystick driver is not present."); break;
		case MMSYSERR_INVALPARAM: printf("An invalid parameter was passed."); break;
		case MMSYSERR_BADDEVICEID: printf("The specified joystick identifier is invalid."); break;
		case JOYERR_UNPLUGGED: printf("The specified joystick is not connected to the system."); break;
		default:  break;
	}
	*Buttons = 0;
	*AccX = 0.0;
	*AccY = 0.0; 
	*AccZ = 0.0;
	return 0;
}

int getCalibratedSensorData(int sensorID, double *AccX, double *AccY, double *AccZ, unsigned int *Buttons, double CalibData[MAXSENSORS][3]) {
	if(getRawSensorData(sensorID, AccX, AccY, AccZ, Buttons)) {
		*AccX -= CalibData[sensorID][X];
		*AccY -= CalibData[sensorID][Y];
		*AccZ -= CalibData[sensorID][Z];
		return 1;
	} 
	return 0;
}

unsigned int joyGetNumDevicesConnected(void) {
	unsigned int  JoyID, nDevices, nDevicesConnected=0;
	JOYINFOEX ji;
	ji.dwSize = sizeof(JOYINFOEX);
	nDevices = joyGetNumDevs();

	for (JoyID=JOYSTICKID1; JoyID<nDevices; JoyID++) {
		if (joyGetPosEx(JoyID, &ji)==JOYERR_NOERROR){
			nDevicesConnected++;
		}
	}
	return nDevicesConnected;
}


//Get the average reading
void calibrateAllSensors(double calibXYZ[MAXSENSORS][3]) {
    double TotalAccX[MAXSENSORS], TotalAccY[MAXSENSORS], TotalAccZ[MAXSENSORS]; 
	double AccX,AccY,AccZ;
    int reads=0, Buttons, i, jid,jidconnected; 
 
    jidconnected = joyGetNumDevicesConnected();

	for(jid=0; jid<jidconnected; jid++) {
		TotalAccX[jid] = 0.0;
		TotalAccY[jid] = 0.0; 
		TotalAccZ[jid] = 0.0;
	}

    for(i=0;i<CALIBRATION_READS; i++) { 
		for(jid=0; jid<jidconnected; jid++) { 
			if (getRawSensorData(jid,&AccX,&AccY,&AccZ,&Buttons)) {
                TotalAccX[jid]+= AccX;
				TotalAccY[jid]+= AccY;
				TotalAccZ[jid]+= AccZ;
				reads++;
			}  
        }
    }

	for(jid=0; jid<jidconnected; jid++) {
		calibXYZ[jid][X] = TotalAccX[jid] / reads;
		calibXYZ[jid][Y] = TotalAccY[jid] / reads; 
		calibXYZ[jid][Z] = 1.0 - TotalAccZ[jid] / reads;

		printf("ID: %d   CalX: %lf  CalY: %lf  CalZ: %lf\n",jid, calibXYZ[jid][X],calibXYZ[jid][Y],calibXYZ[jid][Z]);
	}
}

void reorderArray(double* incoming, double* outgoing, int index, int howFarBack) {
	int i;
	int mostRecent = index % HOWLONG;
	for (i = 0; i < howFarBack; i++) {
		if ((mostRecent - i) < 0)
			mostRecent += HOWLONG;
		outgoing[howFarBack - 1 - i] = incoming[mostRecent - i];
	}
}

int openFile(double* arrX, double* arrY, double* arrZ, char* filename) {
	/**************************************
	 * Opens reference file to compare to *
	 **************************************/
	FILE* file;
	int i = 0;

	file = fopen(filename, "r");
	if (!file)
		return 0;
	
	while (!feof(file)) {
		fscanf(file, "%lf", &arrX[i]);
		fscanf(file, "%lf", &arrY[i]);
		fscanf(file, "%lf", &arrZ[i]);
		i++;
	}
	fclose(file);
	return 1;
}

double cartesianDifference(double* ref, double* norm, int endOfArray) {
	/******************************************************************
	 *		  Finds the cartesian difference using the equation		  *
	 *  sqrt ((ref1-norm1)^2 + (ref2-norm2)^2 + ... + (refn-normn)^2) *
	 *		  Returns some number. This number will be compared		  *
	 *		 to with the maximum cartesianDifference between the	  *
	 *               test data and the average data.				  *
	 ******************************************************************/
	double sum = 0.0;
	int i;
	for (i = 0; i < endOfArray; i++) {
		sum += (ref[i] - norm[i]) * (ref[i] - norm[i]);
	}
	return sqrt(sum);
}
int checkGesture(double* accX, double* accY, double* accZ, double** refs, struct GESTURESTRUCT* gestureStruct, double threshold, int numReadings) {
	/*****************************************
	 * Returns true if a gesture was found.	 *
	 * Does the cartesian difference of each *
	 * axis and adds them up. Each gesture	 *
	 * has its own calculated threshold		 *
	 *****************************************/
	double stretchedX[LONGNORM];
	double stretchedY[LONGNORM];
	double stretchedZ[LONGNORM];

//	FILE* file = NULL;
//	int i;

	double difference = 0;
/*
	file = fopen("debugtxts/accs.txt", "w");
	if (file) {
		printf("created accs.txt\n");
		for (i = 0; i < numReadings; i++)
			fprintf(file, "%lf\t%lf\t%lf\n", accX[i], accY[i], accZ[i]);
		fclose(file);
	}*/

	if (numReadings > MNSHORT && numReadings <= MXSHORT) {
		if (!shortMotion(accX, accY, accZ, stretchedX, stretchedY, stretchedZ, gestureStruct, numReadings)) {
	/*		file = fopen("differences.txt", "a");
			if (file) {
				fprintf(file, "-1\t");
				fclose(file);
			} */
			return 0;
		} 
	}
	else if (numReadings > MNLONG && numReadings <= MXLONG) {
		if (!longMotion(accX, accY, accZ, stretchedX, stretchedY, stretchedZ, gestureStruct, numReadings)) {
	/*		file = fopen("differences.txt", "a");
			if (file) {
				fprintf(file, "-1\t");
				fclose(file);
			} */
			return 0;
		} 
	}
	switch(gestureStruct->gesture) {
		case DOWN:	difference += cartesianDifference(refs[3 * DOWN + X], stretchedX, SHORTNORM);
					difference += cartesianDifference(refs[3 * DOWN + Y], stretchedY, SHORTNORM);
					difference += cartesianDifference(refs[3 * DOWN + Z], stretchedZ, SHORTNORM);
				//	printf("Difference: %f\t", difference);
					if (difference < threshold) {
						printf("\nMoved down!  VVVV\n");
					//	return 1;
					}
					break;
		case UP:	difference += cartesianDifference(refs[3 * UP + X], stretchedX, SHORTNORM);
					difference += cartesianDifference(refs[3 * UP + Y], stretchedY, SHORTNORM);
					difference += cartesianDifference(refs[3 * UP + Z], stretchedZ, SHORTNORM);
				/*	file = fopen("debugtxts/rawrUp.txt", "w");
					if (file) {
						printf("created rawrUp.txt\n");
						for (i = 0; i < SHORTNORM; i++) {
							fprintf(file, "%lf\t%lf\t%lf\n", stretchedX[i], stretchedY[i], stretchedZ[i]);
						}
						fclose(file);
					}					*/
				//	printf("Difference: %f\t", difference);
					if (difference < threshold) {
						printf("\nMoved up!    ^^^^\n");
				//		return 1;
					}
					break;
		case LEFT:	difference += cartesianDifference(refs[3 * LEFT + X], stretchedX, SHORTNORM);
					difference += cartesianDifference(refs[3 * LEFT + Y], stretchedY, SHORTNORM);
					difference += cartesianDifference(refs[3 * LEFT + Z], stretchedZ, SHORTNORM);
			/*		file = fopen("debugtxts/rawrLeft.txt", "w");
					if (file) {
						printf("created rawrLeft.txt\n");
						for (i = 0; i < SHORTNORM; i++) {
							fprintf(file, "%lf\t%lf\t%lf\n", stretchedX[i], stretchedY[i], stretchedZ[i]);
						}
						fclose(file); 
					}*/
					
				//	printf("Difference: %f\t", difference);
					if (difference < threshold) {
						printf("\nMoved left!  <<<<\n");
					//	return 1;
					}
					break;
		case RIGHT:	difference += cartesianDifference(refs[3 * RIGHT + X], stretchedX, SHORTNORM);
					difference += cartesianDifference(refs[3 * RIGHT + Y], stretchedY, SHORTNORM);
					difference += cartesianDifference(refs[3 * RIGHT + Z], stretchedZ, SHORTNORM);
				//	printf("Difference: %f\t", difference);
					if (difference < threshold) {
						printf("\nMoved right! >>>>\n");
					//	return 1;
					}
					break;
		case ALPHA: difference += cartesianDifference(refs[3 * ALPHA + X], stretchedX, LONGNORM);
					difference += cartesianDifference(refs[3 * ALPHA + Y], stretchedY, LONGNORM);
					difference += cartesianDifference(refs[3 * ALPHA + Z], stretchedZ, LONGNORM);
			/*		file = fopen("alpha.txt", "w");
					if (file) {
						for (i = 0; i < LONGNORM; i++) {
							fprintf(file, "%lf\t%lf\t%lf\n", stretchedX[i], stretchedY[i], stretchedZ[i]);
						}
						fclose(file);
					}*/
				//	printf("Difference: %f\t", difference);
					if (difference < threshold) {
						printf("\nYou ALPHAed! ////\n");
			//			return 1;
					}
					break;
		case CAST:	difference += cartesianDifference(refs[3 * CAST + X], stretchedX, SHORTNORM);
					difference += cartesianDifference(refs[3 * CAST + Y], stretchedY, SHORTNORM); 
					difference += cartesianDifference(refs[3 * CAST + Z], stretchedZ, SHORTNORM);
			//		printf("Difference: %f\t", difference);
					if (difference < threshold) {
						printf("\nYou casted!! ////\n");
			//			return 1;
					}
					break;

		case HADOUK:difference += cartesianDifference(refs[3 * HADOUK + X], stretchedX, SHORTNORM);
					difference += cartesianDifference(refs[3 * HADOUK + Y], stretchedY, SHORTNORM); 
					difference += cartesianDifference(refs[3 * HADOUK + Z], stretchedZ, SHORTNORM);
			//		printf("Difference: %f\tcast\n", difference);
					if (difference < threshold) {
						printf("\nHADOUKEN!!! ////\n");
				//		return 1;
					}
					break;
		default:	return 0;
	}/*
	file = fopen("differences.txt", "a");
	if (file) {
		fprintf(file, "%f\t", difference);
		fclose(file);
	}*/
	return 0;
}

int shortMotion(double* accX, double* accY, double* accZ, double* stretchedX, double* stretchedY, double* stretchedZ, struct GESTURESTRUCT* gestureStruct, int numReadings) {

	double normX[SHORTNORM];
	double normY[SHORTNORM];
	double normZ[SHORTNORM];

	// Need these redundant arrays as the functions expect 2D arrays
	double* accsX[] = {accX};
	double* accsY[] = {accY};
	double* accsZ[] = {accZ};

	double* normsX[] = {normX};
	double* normsY[] = {normY};
	double* normsZ[] = {normZ};

	double* stretchedsX[] = {stretchedX};
	double* stretchedsY[] = {stretchedY};
	double* stretchedsZ[] = {stretchedZ};

	int numReadingsA[] = {numReadings};

//	int i;
//	FILE* file;

	if (!superFunctionShort(accsX, numReadingsA, gestureStruct, X, 1, normsX, NULL) ||
		!superFunctionShort(accsY, numReadingsA, gestureStruct, Y, 1, normsY, NULL) ||
		!superFunctionShort(accsZ, numReadingsA, gestureStruct, Z, 1, normsZ, NULL))
		return 0;

/*	file = fopen("debugtxts/norm.txt", "w");
	if (file) {
		printf("created norm.txt\n");
		for (i = 0; i < SHORTNORM; i++) {
			fprintf(file, "%lf\t%lf\t%lf\n", normX[i], normY[i], normZ[i]);
		}
		fclose(file);
	}
*/
	stretchArrays(normsX, normsY, normsZ, stretchedsX, stretchedsY, stretchedsZ, 1, SHORTNORM, gestureStruct);

	return 1;
}

int longMotion(double* accX, double* accY, double* accZ, double* stretchedX, double* stretchedY, double* stretchedZ, struct GESTURESTRUCT* gestureStruct, int numReadings) {

	double normX[LONGNORM];
	double normY[LONGNORM];
	double normZ[LONGNORM];

	// Need these redundant arrays as the functions expect 2D arrays
	double* accsX[] = {accX};
	double* accsY[] = {accY};
	double* accsZ[] = {accZ};

	double* normsX[] = {normX};
	double* normsY[] = {normY};
	double* normsZ[] = {normZ};

	double* stretchedsX[] = {stretchedX};
	double* stretchedsY[] = {stretchedY};
	double* stretchedsZ[] = {stretchedZ};

	int numReadingsA[] = {numReadings};

//	int i;
//	FILE* file;

	if (!superFunctionLong(accsX, numReadingsA, gestureStruct, X, 1, normsX, NULL) ||
		!superFunctionLong(accsY, numReadingsA, gestureStruct, Y, 1, normsY, NULL) ||
		!superFunctionLong(accsZ, numReadingsA, gestureStruct, Z, 1, normsZ, NULL))
		return 0;

/*	file = fopen("debugtxts/norm.txt", "w");
	if (file) {
		printf("created norm.txt\n");
		for (i = 0; i < LONGNORM; i++) {
			fprintf(file, "%lf\t%lf\t%lf\n", normX[i], normY[i], normZ[i]);
		}
		fclose(file);
	}
*/
	stretchArrays(normsX, normsY, normsZ, stretchedsX, stretchedsY, stretchedsZ, 1, LONGNORM, gestureStruct);

	return 1;
}